searchData={"items":[{"type":"module","title":"DoctestFormatter","doc":"Elixir formatter plugin for formatting Elixir code in Markdown files.","ref":"DoctestFormatter.html"},{"type":"function","title":"DoctestFormatter.features/1","doc":"","ref":"DoctestFormatter.html#features/1"},{"type":"function","title":"DoctestFormatter.format/2","doc":"","ref":"DoctestFormatter.html#format/2"},{"type":"extras","title":"Doctest Formatter","doc":"# Doctest Formatter\n\n![GitHub Workflow status](https://github.com/angelikatyborska/doctest_formatter/actions/workflows/test.yml/badge.svg)\n![version on Hex.pm](https://img.shields.io/hexpm/v/doctest_formatter)\n![number of downloads on Hex.pm](https://img.shields.io/hexpm/dt/doctest_formatter)\n![license on Hex.pm](https://img.shields.io/hexpm/l/doctest_formatter)\n\nAn Elixir formatter for doctests.\n\n![Running mix format formats your doctests](https://raw.github.com/angelikatyborska/doctest_formatter/main/assets/mix-format.gif)","ref":"readme.html"},{"type":"extras","title":"Installation - Doctest Formatter","doc":"The package can be installed by adding `doctest_formatter` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:doctest_formatter, \"~> 0.2.1\", runtime: false}\n  ]\nend\n```\n\nThen, extend your `.formatter.exs` config file by adding the plugin. \n\n```elixir\n# .formatter.exs\n[\n  plugins: [DoctestFormatter],\n  inputs: [\n    # your usual inputs ...\n  ]\n]\n```\n\nElixir 1.13.2 or up is required. Versions lower than 1.13 do not support formatter plugins, and versions 1.13.0 and 1.13.1 do not support formatter plugins for `.ex` files.","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Doctest Formatter","doc":"Run `mix format`.\n\nThis formatter plugin will not only format the Elixir code inside the doctest, but it will format the test's `iex>` prompt as well. It will always use `iex>` for the first line of the test, and `...>` for each next line. For example:\n\n```elixir\n@doc \"\"\"\n  iex> \"Hello, \" <>\n    iex> \"World!\"\n\"\"\"\n\n# becomes:\n\n@doc \"\"\"\n  iex> \"Hello, \" <>\n  ...>   \"World!\"\n\"\"\"\n```","ref":"readme.html#usage"},{"type":"extras","title":"Known limitations - Doctest Formatter","doc":"#","ref":"readme.html#known-limitations"},{"type":"extras","title":"Dynamic value - Doctest Formatter","doc":"This plugin will only format string literals and `s`/`S` sigil literal values of `@doc`/`@moduledoc`. It will not format strings with interpolation or other dynamic values. For example:\n\n```elixir\n# will not be formatted:\n@moduledoc \"\"\"\nA prank calculator by #{author_name}. Always gives the wrong answer.\n\niex> PrankCalculator.add(2,2)\n5\n\"\"\"\n\n# will also not be formatted:\n@intermediate_module_attr \"iex> PrankCalculator.add(2,2)\\n5\"\n@doc @intermediate_module_attr\n```\n\n#","ref":"readme.html#dynamic-value"},{"type":"extras","title":"Formatting conflicts - Doctest Formatter","doc":"This plugin needs to parse the whole `.ex` file into an AST and back into a string in order to be able to update the values of `@moduledoc` and `@doc`. When changing the AST back to the string, the code inevitably has to be formatted. Your formatter options are used in this process, so it shouldn't make any changes that the base Elixir formatter wouldn't, but it might conflict with other plugins that modify Elixir code too.","ref":"readme.html#formatting-conflicts"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"0.2.1 (2024-03-22) - Changelog","doc":"- Do not crash if doctest has no expected result.","ref":"changelog.html#0-2-1-2024-03-22"},{"type":"extras","title":"0.2.0 (2024-02-27) - Changelog","doc":"- Support parsing multiline doctests with `iex>` on all lines, but reformat them using `...>` on every line but the first one.\n- Fix implementation for multiline results. Multiline results are allowed, and they can be terminated with an empty new line or another doctest.\n- Support exception expressions (`** (ModuleName) message`) in results.\n- Desired line length for doctest result now accounts for its indentation.\n- Support doctests with iex prompts with a line number, e.g.: `iex(1)>`.","ref":"changelog.html#0-2-0-2024-02-27"},{"type":"extras","title":"0.1.0 (2024-02-25) - Changelog","doc":"- Initial release.","ref":"changelog.html#0-1-0-2024-02-25"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}